
#ifndef __amiga__

typedef unsigned long ULONG;
typedef char*         STRPTR;

#define NULL 0

#define OpenLibrary(name,ver) 0
#define CloseLibrary(base)
#define Printf(fmt,...)

struct ExecBase;
struct DosLibrary;

#else

#include <proto/exec.h>
#include <proto/dos.h>

#endif

int
_start( ULONG, STRPTR ) __attribute__((regparm (3)));

__asm( "				\n\
         .text;				\n\
         .byte 0x4e, 0xfa, 0x00, 0x03	\n\
					\n\
         movl %ebx, %edx		\n\
         jmp  _start" );

int hello = 3;
int* hellop = &hello;

char local_data[100000];

extern unsigned long (*_CallLib68kPtr)( struct _Regs* r, long o );
extern long long var_in_bss;
extern int var_in_data;

int
_start( ULONG cmd_len, STRPTR cmd_line )
{
  struct ExecBase*   SysBase;
  struct DosLibrary* DOSBase;

  SysBase  = *(struct ExecBase**) 4;
  DOSBase = (struct DosLibrary*) OpenLibrary( "dos.library", 37 );

  if( DOSBase != NULL )
  {
    Printf( "Arguments (%ld characters): %s", cmd_len, (ULONG) cmd_line );
    CloseLibrary( DOSBase );
  }

  (*_CallLib68kPtr)(0,0);

  var_in_data = 1;
  var_in_bss  = 2;
  
  return &hello + var_in_bss + var_in_data;
}

